#pragma once

#include "widget.h"
#include <functional>
#include <SFML/Graphics/RectangleShape.hpp>
#include <SFML/Graphics/Text.hpp>

class Button : public Widget
{
public:
    Button(const std::string& text);

    virtual void input(const sf::Event& event) override;
    virtual void update() override;
    virtual void draw(sf::RenderTarget& target, sf::RenderStates states) const override;
    virtual void setRect(const sf::IntRect& rect) override;
    virtual void setPosition(const sf::Vector2f& position) override;

    void setText(const std::string& text);
    void setCallback(std::function<void(void)> callback);

private:
    sf::RectangleShape _button_content;
    sf::Text _button_text;
};

